000010 IDENTIFICATION DIVISION.
000020 PROGRAM-ID. TESTREG.
000030 DATE-COMPILED.
000040* ------------------------: Program to demonstrate using the
000050* 			: registry with GUI ScreenIO.
000060*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000070 ENVIRONMENT DIVISION.
000080*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000090 CONFIGURATION SECTION.
000100 SOURCE-COMPUTER. IBM-PC.
000110 OBJECT-COMPUTER. IBM-PC.
000120*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000130 DATA DIVISION.
000140*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000150 WORKING-STORAGE SECTION.
000160 01  V--VERSION-LEVEL		    PIC 9(3) VALUE 2.
000170*
000180* ------------------------: Copy the registry API copybooks.
000190*
000200	       COPY WIN32API.
000210	       COPY REGISTRY.
000220*
000230* ------------------------: Copy the panels.
000240*
000250	       COPY AREGMAIN.
000260	       COPY AREGPAN.
000270*
000280*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000290 PROCEDURE DIVISION.
000300*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000310*
000320	   PERFORM 0101-DISPLAY-CONTAINER.
000330*
000340* ------------------------: Load the registry data from our
000350* 			: container (you specified your company
000360* 			: and application names in the panel
      * 			: editor in the properties of your
      * 			: main/container panel).
000370*
000380	   MOVE AREGMAIN-COMPANY-NAME-KEY TO P-COMPANY.
000390	   MOVE AREGMAIN-APPLICATION-NAME-KEY TO P-APPLICATION.
000400*
000410* ------------------------: Default to text format.
000420*
000430	   SET P-SAVE-AS-TEXT-ON TO TRUE.
000440*
000450* ------------------------: Display the test panel.
000460*
000470	   PERFORM WITH TEST AFTER
000480		 UNTIL AREGPAN-EVENT-CLOSE-WINDOW
000490		 OR AREGPAN-EVENT-CLOSE-AND-STOP
000500		 OR AREGPAN-MENU-EXIT
000510*
000520	     CALL 'GS' USING AREGPAN-1
000530			     AREGPAN-2
000540			     AREGPAN-3
000550			     AREGPAN-4
000560*
000570	     EVALUATE TRUE
000580*
000590	       WHEN AREGPAN-SAVE
000600		 PERFORM 0102-REGISTRY-SAVE
000610*
000620	       WHEN AREGPAN-RETRIEVE
000630		 PERFORM 0103-REGISTRY-GET
000640*
000650	       WHEN AREGPAN-DELETE-VALUE
000660		 PERFORM 0104-REGISTRY-DELETE-VALUE
000670*
000680	       WHEN AREGPAN-DELETE-SUBKEY
000690		 PERFORM 0105-REGISTRY-DELETE-SUBKEY
000700*
000710	       WHEN OTHER
000720		 CONTINUE
000730*
000740	     END-EVALUATE
000750*
000760	   END-PERFORM.
000770*
000780* ------------------------: Close the container.
000790*
000800	   SET AREGMAIN-DO-CLOSE TO TRUE.
000810	   PERFORM 0101-DISPLAY-CONTAINER.
000820*
000830	   STOP RUN.
000840*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000850 0100-GS-UTILITY SECTION.
000860* -====-
000870 0101-DISPLAY-CONTAINER.
000880* 			:---------------------------------------
000890* ------------------------: Open the application window (the
000900* 			: container for this application)
000910* 			:---------------------------------------
000920*
000930	   CALL 'GS' USING AREGMAIN-1
000940			   AREGMAIN-2
000950			   AREGMAIN-3
000960			   AREGMAIN-4.
000970* -====-
000980 0102-REGISTRY-SAVE.
000990* ------------------------: Load the subkey value from the panel.
001000*
001010	   MOVE P-REGISTRY-SUBKEY TO REGISTRY-SUBKEY.
001020*
001030* ------------------------: Load the value name and associated
001040* 			: data to be placed in the registry.
001050*
001060	   MOVE P-VALUENAME TO REGISTRY-VALUENAME.
001070	   MOVE P-DATA TO REGISTRY-DATA.
001080*
001090* ------------------------: Set TEXT or BINARY format switch.
001100* 			:
001110* 			: If BINARY format,
001120* 			:   you need to say how many bytes
001130* 			:   you want to save;
001140* 			: If TEXT format,
001150* 			:   it's computed for you.
001160*
001170	   IF P-SAVE-AS-TEXT-ON
001180	     SET REGISTRY-DATA-IS-TEXT TO TRUE
001190	   ELSE
001200	     SET REGISTRY-DATA-IS-BINARY TO TRUE
001210	     MOVE P-LENGTH TO REGISTRY-DATA-LENGTH.
001220*
001230* ------------------------: Call the API to update the registry.
001240*
001250	   SET FUNC-REGISTRY-PUT TO TRUE.
001260	   PERFORM 0106-CALL-WINAPI.
001270* -====-
001280 0103-REGISTRY-GET.
001290*
001300* ------------------------: Load the subkey value from the panel.
001310*
001320	   MOVE P-REGISTRY-SUBKEY TO REGISTRY-SUBKEY.
001330*
001340* ------------------------: Load the value name to be retrieved.
001350*
001360	   MOVE P-VALUENAME TO REGISTRY-VALUENAME.
001370*
001380* ------------------------: Call the API to read the registry.
001390*
001400	   SET FUNC-REGISTRY-GET TO TRUE.
001410	   PERFORM 0106-CALL-WINAPI.
001420*
001430* ------------------------: Update panel with the data we got.
001440*
001450	   IF REGISTRY-DATA-IS-TEXT
001460	     SET P-SAVE-AS-TEXT-ON TO TRUE
001470	   ELSE
001480	     SET P-SAVE-AS-BINARY-ON TO TRUE.
001490*
001500	   MOVE REGISTRY-DATA-LENGTH TO P-LENGTH.
001510	   MOVE REGISTRY-DATA TO P-DATA.
001520* -====-
001530 0104-REGISTRY-DELETE-VALUE.
001540*
001550* ------------------------: Load the subkey value from the panel.
001560*
001570	   MOVE P-REGISTRY-SUBKEY TO REGISTRY-SUBKEY.
001580*
001590* ------------------------: Load the value name to be deleted.
001600*
001610	   MOVE P-VALUENAME TO REGISTRY-VALUENAME.
001620*
001630* ------------------------: Call the API to read the registry.
001640*
001650	   SET FUNC-REGISTRY-DELETE-VALUE TO TRUE.
001660	   PERFORM 0106-CALL-WINAPI.
001670*
001680* ------------------------: Update the panel.
001690*
001700	   SET P-SAVE-AS-TEXT-OFF TO TRUE.
001710	   SET P-SAVE-AS-BINARY-OFF TO TRUE.
001720*
001730	   MOVE 0 TO P-LENGTH.
001740	   MOVE SPACE TO P-DATA.
001750* -====-
001760 0105-REGISTRY-DELETE-SUBKEY.
001770*
001780* ------------------------: Load the subkey value from the panel.
001790*
001800	   MOVE P-REGISTRY-SUBKEY TO REGISTRY-SUBKEY.
001810*
001820* ------------------------: Call the API to delete the subkey.
001830*
001840	   SET FUNC-REGISTRY-DELETE-SUBKEY TO TRUE.
001850	   PERFORM 0106-CALL-WINAPI.
001860*
001870* ------------------------: Update the panel.
001880*
001890	   SET P-SAVE-AS-TEXT-OFF TO TRUE.
001900	   SET P-SAVE-AS-BINARY-OFF TO TRUE.
001910*
001920	   MOVE 0 TO P-LENGTH.
001930	   MOVE SPACE TO P-VALUENAME
001940			 P-DATA.
001950* -====-
001960 0106-CALL-WINAPI.
001970*
001980	   CALL 'GS_WINAPI' USING WIN32API-PARMS
001990				  REGISTRY-PARMS
002000				  WIN32API-B
002010				  WIN32API-C
002020				  WIN32API-D
002030				  WIN32API-E
002040				  WIN32API-F.
002050*
002060* ------------------------: If function failed,
002070* 			:   load error message into the
002080* 			:   panel's status bar.
002090*
002100	   IF WIN32API-FAILED
002110	     SET AREGPAN-MESSAGE-BAR-BEEP TO TRUE
002120	     MOVE WIN32API-ERROR-TEXT TO AREGPAN-MESSAGE-TEXT
002130	   ELSE
002140	     SET AREGPAN-MESSAGE-BAR-SILENT TO TRUE
002150	     MOVE 'Success!' TO AREGPAN-MESSAGE-TEXT.
